\documentclass[12pt,a4paper]{article}
\usepackage{comment}
\usepackage[hidelinks]{hyperref}
\usepackage{listings}
\usepackage{graphicx}
\graphicspath{{../Data_modelling/Assets}}

\usepackage{subcaption}
\usepackage{float}
\usepackage[table,xcdraw]{xcolor}
\usepackage{wrapfig}

\usepackage{xcolor}

\definecolor{codegreen}{rgb}{0,0.6,0}
\definecolor{codegray}{rgb}{0.5,0.5,0.5}
\definecolor{codepurple}{rgb}{0.58,0,0.82}
\definecolor{backcolour}{rgb}{0.95,0.95,0.92}

\lstdefinestyle{mystyle}{
    backgroundcolor=\color{backcolour},   
    commentstyle=\color{codegreen},
    keywordstyle=\color{magenta},
    numberstyle=\tiny\color{codegray},
    stringstyle=\color{codepurple},
    basicstyle=\ttfamily\footnotesize,
    breakatwhitespace=false,         
    breaklines=true,                 
    captionpos=b,                    
    keepspaces=true,                 
    numbers=left,                    
    numbersep=5pt,                  
    showspaces=false,                
    showstringspaces=false,
    showtabs=false,                  
    tabsize=2
}

\lstset{style=mystyle}

\title{%
    \vspace*{-5mm}\Huge GW2-SRS DATA MODELLING \\
    \vspace*{2mm}\Large powered by \LaTeX}

\author{\vspace*{-5mm}\large Daniel Lopez: \textbf{Data Modelling}}

\begin{document}
    
    \maketitle

    \begin{figure}[H]
        \centering
        \includegraphics[width=1 \textwidth]{Images/Nuevo_logo_GW2.png}
    \end{figure}

    \newpage

    \section*{4.0 DATA MODELLING}

    \section*{\large 4.1 Introduction}
    \subsection*{\normalsize 4.1.1 Dates and Data}
    All the data used in this study is based on the class performance between May and September. This means
    that, with future nerfs and buffs to classes, values can easily vary. Therefore, this information is only
    relevant in those months. Nonetheless, some classes does not change a lot, so not every value has a chance
    to change.\\

    \subsection*{\normalsize 4.1.2 Model explanation}
    This project data was easier to store on MongoDB than it was on SQL, therefore, a data model was needed not
    only to connect data between tables, but also to have a data schema and keep everything ordered.

    The basic structure of data on MongoDB was explained on the previous EXTRACT part, as the info was saves with
    that specific schema. In SQLite, I needed to create several tables:

    \begin{itemize}
        \item Player's info
        \item Boss names
        \item Profession names
        \item DPS Tables for each boss
    \end{itemize}
    
    \bigskip

    The first table in the list contains names, accounts and two more columns, one of the columns contains a Foreign
    Key (\textbf{FK}) that connects to Boss Names by its Primary Key (\textbf{PK}), as for the second one, it
    contains another FK that connects to Profession names PK. Boss Names and Profession Names are two tables that
    only contains a PK and the names respectively. This was designed this way to prevent data repeating over and over
    when using a PK and FK was by far, the best option.

    \newpage

    Inside the DPS Tables, I had quite a few problems linking data between tables. The DPS tables stored data based 
    on an ID as well, but if \textit{JohnDoe.9100} had ID 30 on the players table and his damage in Vale Guardian corresponds 
    to ID 2 it wouldn't work at all, there was no connection and therefore it leads to error.\\

    The solution was not what I would have done if I had other options in mind, however, it worked fine. I created a FK 
    for every dps table that contained the user account, this way we could just refer the FK to the players table and get 
    the connection done. I thought on doing it with the boss number, but it could also resulted in some problems.

    This choice was mainly done because we use ID as a unique value that represents something, and actually, in a game, your 
    account name is already a unique value that identifies the player and it's also \textbf{immutable}.

    \section*{\large 4.2 Results, Graphs and Analysis}
    The analysis on the project has two main objectives:

    \begin{itemize}
        \item Profession/Class Usage per boss
        \item DPS done per class on each boss
    \end{itemize}

    \bigskip

    \subsection*{\normalsize 4.2.1 Profession/Class Usage}

    \begin{figure}[h!]

        \centering

        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{vg_graph.png}
            \caption{\small W1: Vale Guardian Graph}
        \end{subfigure}%
        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{gors_graph.png}
            \caption{\small W1: Gorseval Graph}
        \end{subfigure}
    \end{figure}

    \newpage

    \begin{figure}[h!]

        \centering

        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{sab_graph.png}
            \caption{\small W1: Sabetha Graph}
        \end{subfigure}%
        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{sloth_graph.png}
            \caption{\small W2: Slothasor Graph}
        \end{subfigure}

        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{matt_graph.png}
            \caption{\small W2: Matthias Gabrel Graph}
        \end{subfigure}%
        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{kc_graph.png}
            \caption{\small W3: Keep Construct Graph}
        \end{subfigure}

        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{xera_graph.png}
            \caption{\small W3: Xera Graph}
        \end{subfigure}%
        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{cairn_graph.png}
            \caption{\small W4: Cairn Graph}
        \end{subfigure}

        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{mo_graph.png}
            \caption{\small W4: Mursaat Graph}
        \end{subfigure}%
        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{sam_graph.png}
            \caption{\small W4: Samarog Graph}
        \end{subfigure}
    \end{figure}

    \newpage

    \begin{figure}[h!]
        
        \centering

        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{dei_graph.png}
            \caption{\small W4: Deimos Graph}
        \end{subfigure}%
        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{sh_graph.png}
            \caption{\small W5: Soulless Horror Graph}
        \end{subfigure}

        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{dhuum_graph.png}
            \caption{\small W5: Dhuum Graph}
        \end{subfigure}%
        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{ca_graph.png}
            \caption{\small W6: Conjured Amalgamate Graph}
        \end{subfigure}

        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{twins_graph.png}
            \caption{\small W6: Twin Largos Graph}
        \end{subfigure}%
        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{q1_graph.png}
            \caption{\small W6: Qadim Graph}
        \end{subfigure}

        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{adina_graph.png}
            \caption{\small W7: Cardinal Adina Graph}
        \end{subfigure}%
        \begin{subfigure}{0.5\textwidth}
            \centering
            \includegraphics[scale=0.4]{sabir_graph.png}
            \caption{\small W7: Cardinal Sabir Graph}
        \end{subfigure}
    \end{figure}

    \newpage

    \begin{wrapfigure}{r}{0.5\textwidth}
        \centering
        \includegraphics[scale=0.4]{prlqadim_graph.png}
        \caption{\small W7: Peerless Qadim Graph}
    \end{wrapfigure}

    All this graphs represent the class usage in each boss, and it stands out that the usage of
    the Mechanist class is huge. Just to be clear, \textbf{all this analysis is made from data 
    between May and September 2022}, therefore, during this period, Mechanist was a rather new 
    class since Guild Wars 2: End of Dragons came out in February 2022.\\

    Since the release of the Mechanist, as well as other classes, it became one of the best choices
    because it could be either support or dps, and it's results in raid were extremely good. We can 
    also see that other classes such as Firebrand is also quite high on the graph, and this is also
    due to Firebrand's versatility. Guild Wars 2 is a game where versatility in terms of raid and 
    fractals is really important, abilities that can provide \textbf{aegis}, \textbf{alacrity} and 
    \textbf{quickness} are three of the key support buffs, while \textbf{power} and \textbf{fury}
    are two of the key damage buffs. This is why classes like Guardian and Engineer are always on 
    top of the usage graphs.\\

    Each boss also has certain classes that perform better than others, as some bosses are weaker to
    condition damage and other bosses to power damage. On top of that, each boss also has certain
    mechanics, which normally needs certain classes to perform those specific roles; as an example,
    Peerless Qadim has the \textbf{Pylon} mechanic, and it's normally performed by Deadeyes or Scourges.

    \subsection*{\normalsize 4.2.2 DPS Data Graphs}
    Now that class usage have been seen, it's time to focus a little on dps data. This time, as earlier,
    I did a series of graphs that represent the damage done per class in each boss and on each phase. DPS
    stats seen in graphs are a mean of all the 1000+ rows on each boss table.

    \newpage

    \begin{figure}[h!]
        
        \centering
        
        \includegraphics[width=1 \linewidth]{vg_dps_plot.png}
        \caption{Vale Guardian}
        \includegraphics[width=1 \linewidth]{gors_dps_plot.png}
        \caption{Gorseval The Multifarious}
    \end{figure}

    \newpage

    \begin{figure}[h!]
        
        \centering
        
        \includegraphics[width=1 \linewidth]{sab_dps_plot.png}
        \caption{Sabetha The Saboteur}
    \end{figure}

    Some plots had to be adjusted due to bosses having too many phases, normally bosses have few phases,
    however, I had to adapt the phase system EliteInsights have, which is mainly obtained from the game
    itself.\\

    In Sabetha's battle, there is a main mechanic consisting on destroying cannons that continuously attack
    the battle platform. If the platform falls due to damage, it will destroy and the battle will be lost.
    Therefore, two players are focused on destroying those cannons in an specific timing, while the rest of
    the team fights Sabetha and her minions.

    \newpage

    \begin{figure}[h!]
        
        \centering
        
        \includegraphics[width=1 \linewidth]{sloth_dps_plot.png}
        \caption{Slothasor}
    \end{figure}

    Slothasor is a boss with many phases due to his main mushroom mechanic. It consists of four mushrooms
    that need to be picked in order to clean areas and avoid stepping into venomous floor that kills the
    player slowly. When you pick this mushrooms, your character will stop doing damage to the boss and it
    will turn an enemy target for anyone on your team, therefore, players must be careful not to kill the
    teammate doing this mechanic.\\

    Added to this mechanic, Slothasor will shake his body from time to time causing several conditions on
    players that must be cleaned. Slothasor will also smash the ground and create three blue areas that 
    players need to dodge or else, they will be stunned for a while.\\

    Last mechanic is an active ability that will appear on a random player, this ability is a poison that 
    will drain player's life until he release the ability, and this must be done out of the group as it 
    creates a venomous pool that will also damage other teammates.

    \newpage

    \begin{figure}[h!]
        
        \centering
        
        \includegraphics[width=1 \linewidth]{matt_dps_plot.png}
        \caption{Matthias Gabrel}
    \end{figure}

    Matthias battle is quite special, as its phases are based on a weather happening on the battlefield and
    it affects players as well: ice will slow players, fire will create tornados damaging and stunning players...
    The abomination phase is the one that combines every effect happening before plus, Matthias becomes a bigger
    creature that will have the same movements as the original Matthias.

    \newpage

    \begin{figure}[h!]
        
        \centering
        
        \includegraphics[width=1 \linewidth]{kc_dps_plot.png}
        \caption{Keep Construct}
        \includegraphics[width=1 \linewidth]{xera_dps_plot.png}
        \caption{Xera}
    \end{figure}

    \newpage

    \begin{figure}[h!]
        
        \centering
        
        \includegraphics[width=1 \linewidth]{cairn_dps_plot.png}
        \caption{Cairn The Indomitable}
        \includegraphics[width=1 \linewidth]{mo_dps_plot.png}
        \caption{Mursaat Overseer}
    \end{figure}

    \newpage

    \begin{figure}[h!]
        
        \centering
        
        \includegraphics[width=1 \linewidth]{sam_dps_plot.png}
        \caption{Samarog}
    \end{figure}

    As seen before, there are also bosses like Cairn that have a single phase, and this is due the kind of battle
    it has. Cairn battle it's based on a 100 to 0 battle, it has certain mechanics that everyone needs to do, but
    those mechanics doesn't stop some players from doing damage or being outside of the group needing to have in 
    certain objectives in mind. A way to explain this would be Samarog; his battle is quite straight-forward, but,
    at every 33\% HP lost he will exit the battlefield and another fight phase with two other enemies will began.

    \newpage

    \begin{figure}[h!]
        
        \centering
        
        \includegraphics[width=0.8 \linewidth]{dei_dps_plot.png}
        \caption{Deimos}
        \includegraphics[width=0.9 \linewidth]{sh_dps_plot.png}
        \caption{Soulless Horror}
    \end{figure}

    \newpage

    \begin{figure}[h!]
        
        \centering
        
        \includegraphics[width=1 \linewidth]{dhuum_dps_plot.png}
        \caption{Dhuum}
        \includegraphics[width=1 \linewidth]{ca_dps_plot.png}
        \caption{Conjured Amalgamate}
    \end{figure}

    \newpage

    \begin{figure}[h!]
        
        \centering
        
        \includegraphics[width=1 \linewidth]{twins_dps_plot.png}
        \caption{Twin Largos}
        \includegraphics[width=1 \linewidth]{q1_dps_plot.png}
        \caption{Qadim}
    \end{figure}

    \newpage

    \begin{figure}[h!]
        
        \centering
        
        \includegraphics[width=1 \linewidth]{adina_dps_plot.png}
        \caption{Cardinal Adina}
        \includegraphics[width=1 \linewidth]{sabir_dps_plot.png}
        \caption{Cardinal Sabir}
    \end{figure}

    \newpage

    \begin{figure}[h!]
        
        \centering
        
        \includegraphics[width=1 \linewidth]{prlqadim_dps_plot.png}
        \caption{Qadim The Peerless}
    \end{figure}

    Twin Largos is a really special boss, because it actually contains two bosses in one fight, however, it is 
    separated between extremely clear phases that, in game, are specified by platforms. Each boss, Nikare and
    Kenut, have three platforms each, which define their phases quite well.\\

    As for Qadim The Peerless, classes like Scourges and Deadeyes are the ones playing a \textbf{Pylon} role
    and therefore, they are used almost a 90\% of the times.

    \newpage

    \subsection*{\normalsize 4.2.3 Analysis}

    \begin{wrapfigure}{r}{0.5\textwidth}
        \centering
        \includegraphics[scale=0.7]{class_percentage.png}
    \end{wrapfigure}

    After seeing all the previous graphs is quite obvious how some classes are used a lot more than others.
    This changes a lot as it is important to know that buffs and nerfs get done within the game after some 
    time, which in the end keeps the game balanced.\\

    \textbf{Important}: This whole project data analysis was made using the May to September 2022 status of
    the game, therefore, with future changes and also, more data, it's highly probable that results change.\\

    On this side figure, I wanted to show data in a more understandable format. All this results are based on
    a global table and, as it portrays, \textbf{Mechanist} and  \textbf{Firebrand} are the two classes with 
    higher usage on a global percentage. As I explained earlier, Mechanist is one of the most versatile classes
    the game ever had, and yes, other classes like Firebrand is also quite versatile. In terms of damage, this
    also varies from encounter to encounter but some professions still stand out more since they can have an 
    easier burst damage, which is essentially based on the class rotation.

    \newpage

    Rotations are the main damage source classes have, as guild web-pages like \textbf{Snowcrows} or \textbf{LuckyNoobs} made sure to
    optimize this so every player can make use of the class full potential by applying the correct ability order
    that creates several effects such as buffs, field effects and combos.\\

    \textbf{Extra}:\\
    To understand what \textbf{Snowcrows} and \textbf{LuckyNoobs} does, I will leave links to the pages but also, explain what they
    do and contribute to the Guild Wars 2 community. Since Fractals and Raids were release as new PvE modes, some 
    guilds and players tried to find ways to optimize how this stages could be cleared. This is how this guilds 
    were born, but they are not something new as they always existed on other games like World Of Warcraft for PvP.\\

    What they give to players are builds adapted to the current meta-game and they also revise them from time to time
    so all build are also up-to-date with new changes that Guild Wars team release into the game.

    \begin{itemize}
        \item SnowCrows \href{https://snowcrows.com/}{\textbf{here}}.
        \item LuckyNoobs \href{https://lucky-noobs.com/}{\textbf{here}}.
    \end{itemize}

    \begin{figure}[b]
        \centering
        \begin{subfigure}[b]{0.15\linewidth}
            \href{https://github.com/icharo-tb}{\includegraphics[width=\linewidth]{Images/GitHub-logo.png}}
        \end{subfigure}
        \begin{subfigure}[b]{0.15\linewidth}
            \href{https://www.linkedin.com/in/danielopezpajares/}{\includegraphics[width=\linewidth]{Images/LinkedIn_Logo.png}}
        \end{subfigure}
        \begin{subfigure}[b]{0.15\linewidth}
            \href{https://gitlab.com/daniel.lopez.pajares.2021}{\includegraphics[width=\linewidth]{Images/GitLab_logo.png}}
        \end{subfigure}
    \end{figure}
\end{document}